package com.ejie.ab79.dao.actuaciones;

import com.ejie.ab79.model.actuaciones.TiposActuacion;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/**
 * TiposActuacionDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class TiposActuacionDaoImpl implements TiposActuacionDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDTIPOACTUACION", "DESCRIPCIONCASTELLANO",
			"DESCRIPCIONEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<TiposActuacion> rwMap = new RowMapper<TiposActuacion>() {
		public TiposActuacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new TiposActuacion(resultSet.getLong("IDTIPOACTUACION"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"));
		}
	};

	private RowMapper<TiposActuacion> rwMapPK = new RowMapper<TiposActuacion>() {
		public TiposActuacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new TiposActuacion(resultSet.getLong("IDTIPOACTUACION"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<TiposActuacion>> rwMapJerarquia = new RowMapper<JerarquiaDto<TiposActuacion>>() {
		public JerarquiaDto<TiposActuacion> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			TiposActuacion tiposactuacion = new TiposActuacion(resultSet.getLong("IDTIPOACTUACION"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<TiposActuacion> jerarquia = new JerarquiaDto<TiposActuacion>();
			jerarquia.setModel(tiposactuacion);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the TiposActuacion table.
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @return TiposActuacion
	 */
	public TiposActuacion add(TiposActuacion tiposactuacion) {
		String query = "INSERT INTO TIPOS_ACTUACION (ID_TIPO_ACTUACION, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?)";
		this.jdbcTemplate.update(query, tiposactuacion.getIdTipoActuacion(), tiposactuacion.getDescripcionCastellano(),
				tiposactuacion.getDescripcionEuskera(), tiposactuacion.getFechaRegistro(),
				tiposactuacion.getUsuarioRegistro());
		return tiposactuacion;
	}

	/**
	 * Updates a single row in the TiposActuacion table.
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @return TiposActuacion
	 */
	public TiposActuacion update(TiposActuacion tiposactuacion) {
		String query = "UPDATE TIPOS_ACTUACION SET DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=?, FECHA_REGISTRO=?, USUARIO_REGISTRO=? WHERE ID_TIPO_ACTUACION=?";
		this.jdbcTemplate.update(query, tiposactuacion.getDescripcionCastellano(),
				tiposactuacion.getDescripcionEuskera(), tiposactuacion.getFechaRegistro(),
				tiposactuacion.getUsuarioRegistro(), tiposactuacion.getIdTipoActuacion());
		return tiposactuacion;
	}

	/**
	 * Finds a single row in the TiposActuacion table.
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @return TiposActuacion
	 */
	@Transactional(readOnly = true)
	public TiposActuacion find(TiposActuacion tiposactuacion) {
		String query = "SELECT t1.ID_TIPO_ACTUACION IDTIPOACTUACION, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM TIPOS_ACTUACION t1  WHERE t1.ID_TIPO_ACTUACION = ?  ";

		List<TiposActuacion> tiposactuacionList = this.jdbcTemplate.query(query, this.rwMap,
				tiposactuacion.getIdTipoActuacion());
		return (TiposActuacion) DataAccessUtils.uniqueResult(tiposactuacionList);
	}

	/**
	 * Removes a single row in the TiposActuacion table.
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @return
	 */
	public void remove(TiposActuacion tiposactuacion) {
		String query = "DELETE FROM TIPOS_ACTUACION WHERE ID_TIPO_ACTUACION=?";
		this.jdbcTemplate.update(query, tiposactuacion.getIdTipoActuacion());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<TiposActuacion> getMultiple(TiposActuacion filterTiposActuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterTiposActuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, TiposActuacion.class, params,
				"ID_TIPO_ACTUACION");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the TiposActuacion table.
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TiposActuacion>
	 */
	@Transactional(readOnly = true)
	public List<TiposActuacion> findAll(TiposActuacion tiposactuacion, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM TIPOS_ACTUACION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(tiposactuacion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		// if (tableRequestDto != null) {
		// query = TableManager.getPaginationQuery(tableRequestDto, query,
		// TiposActuacionDaoImpl.ORDER_BY_WHITE_LIST);
		// }

		return (List<TiposActuacion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the TiposActuacion table using like.
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposActuacion>
	 */
	@Transactional(readOnly = true)
	public List<TiposActuacion> findAllLike(TiposActuacion tiposactuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM TIPOS_ACTUACION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(tiposactuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		// if (tableRequestDto != null) {
		// query = TableManager.getPaginationQuery(tableRequestDto, query,
		// TiposActuacionDaoImpl.ORDER_BY_WHITE_LIST);
		// }

		return (List<TiposActuacion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the TiposActuacion table.
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(TiposActuacion tiposactuacion) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM TIPOS_ACTUACION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(tiposactuacion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the TiposActuacion table using like.
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(TiposActuacion tiposactuacion, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM TIPOS_ACTUACION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(tiposactuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of TiposActuacion selected for rup_table
	 *
	 * @param tiposactuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposActuacion>>
	 */
	@Override
	public List<TableRowDto<TiposActuacion>> reorderSelection(TiposActuacion tiposactuacion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM TIPOS_ACTUACION t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(tiposactuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, TiposActuacion.class,
				filterParamList, "ID_TIPO_ACTUACION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<TiposActuacion>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            TiposActuacion
	 * @param searchParams
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposActuacion>>
	 */
	@Override
	public List<TableRowDto<TiposActuacion>> search(TiposActuacion filterParams, TiposActuacion searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM TIPOS_ACTUACION t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, TiposActuacion.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_TIPO_ACTUACION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<TiposActuacion>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filtertiposactuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(TiposActuacion filtertiposactuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM TIPOS_ACTUACION t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filtertiposactuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, TiposActuacion.class,
				query, params, "ID_TIPO_ACTUACION");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical TiposActuacion table.
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<TiposActuacion>>
	 */
	@Override
	public List<JerarquiaDto<TiposActuacion>> findAllLikeJerarquia(TiposActuacion filterTiposActuacion,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM TIPOS_ACTUACION t1 ");
		List<String> from = new ArrayList<String>();
		from.add("TIPOS_ACTUACION");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterTiposActuacion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_TIPO_ACTUACION", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		// if (tableRequestDto != null) {
		// query = TableManagerJerarquia.getPaginationQuery(tableRequestDto,
		// query, TiposActuacionDaoImpl.ORDER_BY_WHITE_LIST);
		// }

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(TiposActuacion filterTiposActuacion, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM TIPOS_ACTUACION t1 ");
		List<String> from = new ArrayList<String>();
		from.add("TIPOS_ACTUACION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterTiposActuacion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_TIPO_ACTUACION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<TiposActuacion>>
	 */
	@Override
	public List<TableRowDto<TiposActuacion>> findAllChild(TiposActuacion filterTiposActuacion,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM TIPOS_ACTUACION t1 ");
		List<String> from = new ArrayList<String>();
		from.add("TIPOS_ACTUACION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterTiposActuacion, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_TIPO_ACTUACION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<TiposActuacion>(this.rwMapPK, "ID_TIPO_ACTUACION"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the TiposActuacion entity
	 *
	 * @param tiposactuacion
	 *            TiposActuacion Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(TiposActuacion tiposactuacion) {

		StringBuilder where = new StringBuilder(TiposActuacionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (tiposactuacion != null && tiposactuacion.getIdTipoActuacion() != null) {
			where.append(" AND t1.ID_TIPO_ACTUACION = ?");
			params.add(tiposactuacion.getIdTipoActuacion());
		}
		if (tiposactuacion != null && tiposactuacion.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(tiposactuacion.getDescripcionCastellano());
		}
		if (tiposactuacion != null && tiposactuacion.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(tiposactuacion.getDescripcionEuskera());
		}
		if (tiposactuacion != null && tiposactuacion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(tiposactuacion.getFechaRegistro());
		}
		if (tiposactuacion != null && tiposactuacion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(tiposactuacion.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the TiposActuacion entity
	 *
	 * @param tiposactuacion
	 *            TiposActuacion Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(TiposActuacion tiposactuacion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(TiposActuacionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (tiposactuacion != null && tiposactuacion.getIdTipoActuacion() != null) {
			where.append(" AND t1.ID_TIPO_ACTUACION = ?");
			params.add(tiposactuacion.getIdTipoActuacion());
		}
		if (tiposactuacion != null && tiposactuacion.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(tiposactuacion.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + tiposactuacion.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (tiposactuacion != null && tiposactuacion.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(tiposactuacion.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + tiposactuacion.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (tiposactuacion != null && tiposactuacion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(tiposactuacion.getFechaRegistro());
		}
		if (tiposactuacion != null && tiposactuacion.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(tiposactuacion.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + tiposactuacion.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
